import 'dart:typed_data';
import 'package:superlu/async/slu_ddefs.dart' as ddefs;

main() async {
  var n = 5;
  var _a = [2.0, 3.0, 3.0, -1.0, 4.0, 4.0, -3.0, 1.0, 2.0, 2.0, 6.0, 1.0];
  var _asub = [0, 1, 0, 2, 4, 1, 2, 3, 4, 2, 1, 4];
  var _xa = [0, 2, 5, 9, 10, 12];
  var _rhs = [8.0, 45.0, -3.0, 3.0, 19.0];

  var a = new Float64List.fromList(_a);
  var asub = new Int32List.fromList(_asub);
  var xa = new Int32List.fromList(_xa);
  var rhs = new Float64List.fromList(_rhs);

  var superlu = new ddefs.SuperLU();
  var factors =
      await superlu.factor(a, asub, xa, permc_spec: ddefs.ColPerm.NATURAL);
  rhs = await factors.solve(n, 1, rhs);

  print(rhs);

  factors.free();
}
